<?php

function MySQLCreate()
{
    //NeoLog( 3, "DB_HOSTNAME: " . DB_HOSTNAME );
    //NeoLog( 3, "DB_USERNAME: " . DB_USERNAME );
    //NeoLog( 3, "DB_PASSWORD: " . DB_PASSWORD );
    //NeoLog( 3, "SSL_BASE:    " . SSL_BASE    );

    $m = mysqli_init();

    if ( !$m )
    {
        NeoLog( "Could not initialise 'mysqli'" );
        exit;
    }

    ConfigureSSL( $m, SSL_BASE, DB_HOSTNAME );

    $connection = @$m->real_connect( DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, null, null, null, MYSQLI_CLIENT_SSL_DONT_VERIFY_SERVER_CERT );

    if ( !$connection )
    {
        if ( "No such file or directory" == $m->error )
        {
            NeoLog( "Aborting: could not connect to " . DB_HOSTNAME . " using " . DB_USERNAME . ":" . DB_PASSWORD );
            exit;
        }
        else
        {
            NeoLog( "Aborting: unexpected error: " . $m->error );
            exit;
        }
    }

    return $m; // Same as $m.
}

function MySQLInfo( $mysql, $sql_query )
{
    $tuples   = array();
    $resource = mysqli_query( $mysql, $sql_query );

    if ( !$resource )
    {
        NeoLog( $mysql->error );
        exit;
    }
    else
    {
        while ( $row = mysqli_fetch_array( $resource, MYSQLI_ASSOC ) )
        {
            $tuples[] = $row;
        }
    }
    return $tuples;
}

function MySQLFunction( $db, $function )
{
    $ret      = null;
    $sql      = "SELECT $function";
    $m        = MySQLCreate();

    if ( ! mysqli_select_db( $m, $db ) )
    {
        NeoLog( "Aborting, could not select database! " . $db );
        exit;
    }
    else
    {
        $resource = mysqli_query( $m, $sql );

        if ( True === $resource )
        {
            $ret = True;
        }
        else
        if( False === $resource )
        {
            $ret = False;
        }
        else
        if ( $resource )
        {
            $row = mysqli_fetch_array( $resource, MYSQLI_NUM );
            $ret = array_key_exists( 0, $row ) ? $row[0] : NULL;
            mysqli_free_result( $resource );
        }
        else
        {
            NeoLog( "Aborting, " . $m->error );
            exit;
        }
    }
    return $ret;
}

function MySQLProcedure( $db, $sp_call, &$procedure = "" )
{
    $ret = False;

    $proc_name = $sp_call->proc_name;
    $arguments = $sp_call->arguments;

    $m = MySQLCreate();

    if ( ! mysqli_select_db( $m, $db ) )
    {
        NeoLog( "Aborting, could not select database! " . $db );
        exit;
    }
    else
    {
        $filtered = array();
        foreach( $arguments as $argument )
        {
            if ( is_null( $argument ) )
            {
                $filtered[] = "NULL";
            }
            else
            {
                $filtered[] = "'" . mysqli_real_escape_string( $m, $argument ) . "'";
            }
        }

        $procedure = $proc_name . "(" . join( ",", $filtered ) . ")";

        $sql_query = "CALL " . $procedure;

        if ( "wab_test" == $proc_name )
        {
            NeoLog( "Test: " . $sql_query );
        }

        $resource  = mysqli_query( $m, $sql_query );

        if ( True === $resource )
        {
            $ret = array();
        }
        else
        if( False === $resource )
        {
            $ret = $m->error;
        }
        else
        if ( $resource )
        {
            $ret = array();

            while ( $row = mysqli_fetch_array( $resource, MYSQLI_ASSOC ) )
            {
                $ret[] = (object) $row;
            }

            mysqli_free_result( $resource );
        }
        else
        {
            NeoLog( "Aborting, " . $m->error );
            exit;
        }
    }
    return $ret;
}

